package com.weaver.seconddev.sxjg.config;

import com.zaxxer.hikari.HikariDataSource;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Value;
import org.springframework.context.annotation.Configuration;
import org.springframework.stereotype.Component;

import javax.sql.DataSource;

/**
 * 数据库连接池，单例,二开服务（以后所有seconddev都放在这里）
 * @author liuhao
 */
@Configuration
@Component
public class EbDbDataSourceConfigResp {
    private static final Logger log = LoggerFactory.getLogger(EbDbDataSourceConfigResp.class);

    private static String url;

    private static String driverClassName;

    private static String username;

    private static String password;
    private volatile static HikariDataSource dataSource;

    public static DataSource dbDataSource() {
        if (dataSource ==null){
            synchronized (DataSource.class){
                if (dataSource == null){
                    dataSource = new HikariDataSource();
                    dataSource.setDriverClassName(driverClassName);
                    dataSource.setJdbcUrl(url);
                    dataSource.setUsername(username);
                    dataSource.setPassword(password);
                    // 连接池参数
                    dataSource.setMaximumPoolSize(20);
                    dataSource.setPoolName("MyHikariCP12");
                    dataSource.setConnectionTimeout(30000);
                    return dataSource;
                }
            }
        }
        return dataSource;
    }

    @Value("${spring.datasource.urlebresp}")
    public void setUrl(String url) {
        EbDbDataSourceConfigResp.url = url;
    }

    @Value("${spring.datasource.driver-class-name}")
    public void setDriverClassName(String driverClassName) {
        EbDbDataSourceConfigResp.driverClassName = driverClassName;
    }

    @Value("${spring.datasource.username}")
    public void setUsername(String username) {
        EbDbDataSourceConfigResp.username = username;
    }

    @Value("${spring.datasource.password}")
    public void setPassword(String password) {
        EbDbDataSourceConfigResp.password = password;
    }
}
