package com.weaver.seconddev.sxjg.controller;

import com.weaver.common.authority.annotation.WeaPermission;
import com.weaver.common.base.entity.result.WeaResult;
import com.weaver.seconddev.sxjg.service.JoinPositionRule;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.RestController;

import java.util.HashMap;
import java.util.Map;

@RestController
@RequestMapping("/papi/secondev/sxjg")
@Slf4j
public class CheckPositionController {

    @Autowired
    private JoinPositionRule joinPositionRule;

    /**
     *一个单位只允许投三个职位；
     * --- 分校招和社招不？我记得陕建 社招和校招，投递本来就是有区别对待的。
     * 2、高层次毕业院校只允许 清华大学 北京大学 浙江大学 哈尔滨工业大学 东南大学 天津大学 同济大学的投递
     */
    @WeaPermission(publicPermission = true)
    @PostMapping("/checkPosition")
    public WeaResult<Map<String,String>> check(
            @RequestParam("talentId") String talentId,
            @RequestParam("userId") String userId,
            @RequestParam("userName") String userName,
            @RequestParam("resumeId") String resumeId,
            @RequestParam("positionId") String positionId
    ){
        Map<String,String> rs = new HashMap<>();
        rs = joinPositionRule.JoinPositionRule(talentId,userId,userName,positionId,resumeId);
        return WeaResult.success(rs);
    }
}