/**
 * @use附件重发 ---其他入职
 * @author 刘浩
 *
 * 其他人员入职附件异常重发ncc
 * 3
 */
package com.weaver.seconddev.sxjg.esb;

import cn.hutool.core.collection.CollectionUtil;
import com.alibaba.fastjson.JSONArray;
import com.alibaba.fastjson.JSONObject;
import com.weaver.common.base.entity.result.WeaResult;
import com.weaver.esb.api.rpc.EsbServerlessRpcRemoteInterface;
import com.weaver.eteams.file.client.file.FileData;
import com.weaver.file.ud.api.FileDownloadService;
import com.weaver.seconddev.sxjg.config.EbDbDataSourceConfig;
import com.weaver.seconddev.sxjg.config.EbDbDataSourceConfigResp;
import com.weaver.seconddev.sxjg.util.NccApiUtil;
import com.weaver.seconddev.sxjg.util.NccResultUtil;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.jdbc.core.JdbcTemplate;
import org.springframework.stereotype.Service;

import java.io.IOException;
import java.io.InputStream;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

@Service("esb_errorresendqt_howe")
public class ErrorfjResendToNccQt implements EsbServerlessRpcRemoteInterface {
    private static final Logger log = LoggerFactory.getLogger(ErrorfjResendToNccQt.class);
    private JdbcTemplate jdbcTemplate = new JdbcTemplate(EbDbDataSourceConfig.dbDataSource());
    private JdbcTemplate jdbcTemplateresp = new JdbcTemplate(EbDbDataSourceConfigResp.dbDataSource());

    @Autowired
    private FileDownloadService fileDownloadService;
    @Override
    public WeaResult<Map<String, Object>> execute(Map<String, Object> params) {
        Map<String, Object> finresult = new HashMap<>();
        finresult.put("code",200);
        String idtype = (String) params.get("idtype");//证件类型
        String id = (String) params.get("id");//证件号码
        String rzid = (String) params.get("rzid");//入职id
        String collectid = (String) params.get("collectid");
        if (collectid == null || collectid.length() == 0) {
            finresult.put("code",500);
            finresult.put("msg","当前人员并未进行信息采集");
            return WeaResult.success(finresult);
        }
        String sql = "select ncc_pk from ft_ncczjlx where ncc_name = '"+idtype+"'";
        Map<String, Object> srrr = jdbcTemplateresp.queryForMap(sql);
        String idtypePk =(String) srrr.get("ncc_pk");
        try {
            //传附件
            log.error("howec:::::::传附件");
            JSONObject jsonObject2 = new JSONObject();
            jsonObject2.put("id",id);
            jsonObject2.put("idtype",idtypePk);
            JSONArray r11 = getFjByCollectId(collectid);
            if(r11.size() == 0) {
                return WeaResult.success(finresult);
            }
            jsonObject2.put("data",r11);
            NccApiUtil nccApiUtil = new NccApiUtil();
            nccApiUtil.init();
            String token = nccApiUtil.getToken();
            String url = nccApiUtil.getBaseUrl()+"nccloud/api/hrhi/openAPI/attachment/upload";
            String rs11 = nccApiUtil.doJsonPost(url,token,jsonObject2.toJSONString());
            NccResultUtil rs = new NccResultUtil(rs11);
            if(rs.getResult()){
                sql = "update uf_rcrt_entry_manage_qtry set fjtbsfyc = '0',entry_status = '1' where id = "+rzid;
                jdbcTemplate.execute(sql);
                return WeaResult.success(finresult);
            }else {
                finresult.put("code",500);
                finresult.put("msg",rs.getDescription());
                return WeaResult.success(finresult);
            }
        }catch (Exception e){
            e.printStackTrace();
            finresult.put("code",500);
            finresult.put("msg",e.getMessage());
            return WeaResult.success(finresult);
        }
    }

    private JSONArray getFjByCollectId(String collectid) {
        JSONArray array1 = new JSONArray();
        String sql = "select dyxlxlzxwz,dexlxlzxwz,dsxlxlzxwz,dsixlxlzxwz,gwz,zcz,zyzgz,aqsckhz,jqmgzp,sfzzp from uf_rcrt_entry_collect_qtry where id = "+collectid;
        Map<String, Object> map = jdbcTemplate.queryForMap(sql);
        String dyxlxlzxwz = map.get("dyxlxlzxwz") == null ? "0" : (String)map.get("dyxlxlzxwz");
        String dexlxlzxwz = map.get("dexlxlzxwz") == null ? "0" : (String)map.get("dexlxlzxwz");
        String dsxlxlzxwz = map.get("dsxlxlzxwz") == null ? "0" : (String)map.get("dsxlxlzxwz");
        String dsixlxlzxwz = map.get("dsixlxlzxwz") == null ? "0" : (String)map.get("dsixlxlzxwz");
        String gwz = map.get("gwz") == null ? "0" : (String)map.get("gwz");
        String zcz = map.get("zcz") == null ? "0" : (String)map.get("zcz");
        String zyzgz = map.get("zyzgz") == null ? "0" : (String)map.get("zyzgz");
        String aqsckhz = map.get("aqsckhz") == null ? "0" : (String)map.get("aqsckhz");
        String sfzzp = map.get("sfzzp") == null ? "0" : (String)map.get("sfzzp");
        String jqmgzp = map.get("jqmgzp") == null ? "0" : (String)map.get("jqmgzp");
        List<FileData> file1 = getDxDt(dyxlxlzxwz);//第一学历学历证学位证
        List<FileData> file2 =getDxDt(dexlxlzxwz);//第二学历学历证学位证
        List<FileData> file3 = getDxDt(dsxlxlzxwz);//第三学历学历证学位证
        List<FileData> file4 = getDxDt(dsixlxlzxwz);//第四学历学历证学位证
        List<FileData> file5 = getDxDt(gwz);//岗位证
        List<FileData> file6 = getDxDt(zcz);//职称证
        List<FileData> file7 = getDxDt(zyzgz);//执业资格证
        List<FileData> file8 = getDxDt(aqsckhz);//安全生产考核证
        List<FileData> file9 = getDxDt(sfzzp);//身份证
        List<FileData> file10 = getDxDt(jqmgzp);//近期免冠照片
        if(CollectionUtil.isNotEmpty(file1)) {
            JSONObject rs1 = new JSONObject();
            rs1.put("file_name","第一学历学历证学位证");
            JSONArray json1 = new JSONArray();
            for(FileData f : file1) {
                JSONObject r1 = new JSONObject();
                String filename = "";
                String name1 = f.getFileObj().getName();
                log.error("name::::::"+name1);
                if(name1.contains(".")) {
                    String names[] = name1.split("\\.");
                   filename = names[names.length-1];
                }
                if(filename.length() > 0) {
                    r1.put("file_type",filename.toLowerCase());
                }else{
                    r1.put("file_type",f.getFileObj().getType());
                }
                log.error("howec:::::::::xxxxx21:"+f.getFileObj().getName());
                log.error("howec:::::::::xxxxx1:"+f.getFileObj().getType());
                log.error("howec:::::::::xxxxx2:"+f.getLoadUrl());
                InputStream stream1 = f.getInputStream();
                byte[] a = getByteData(stream1);
                r1.put("filebytes",a);
                json1.add(r1);
            }
            rs1.put("filebytes_array",json1);
            array1.add(rs1);
        }
        if(CollectionUtil.isNotEmpty(file2)) {
            JSONObject rs1 = new JSONObject();
            rs1.put("file_name","第二学历学历证学位证");
            JSONArray json1 = new JSONArray();
            for(FileData f : file2) {
                JSONObject r1 = new JSONObject();
                String filename = "";
                String name1 = f.getFileObj().getName();
                if(name1.contains(".")) {
                    String names[] = name1.split("\\.");
                   filename = names[names.length-1];
                }
                if(filename.length() > 0) {
                    r1.put("file_type",filename.toLowerCase());
                }else{
                    r1.put("file_type",f.getFileObj().getType());
                }
                log.error("howec:::::::::xxxxx21:"+f.getFileObj().getName());
                log.error("howec:::::::::xxxxx1:"+f.getFileObj().getType());
                log.error("howec:::::::::xxxxx2:"+f.getLoadUrl());
                InputStream stream1 = f.getInputStream();
                byte[] a = getByteData(stream1);
                r1.put("filebytes",a);
                json1.add(r1);
            }
            rs1.put("filebytes_array",json1);
            array1.add(rs1);
        }
        if(CollectionUtil.isNotEmpty(file3)) {
            JSONObject rs1 = new JSONObject();
            rs1.put("file_name","第三学历学历证学位证");
            JSONArray json1 = new JSONArray();
            for(FileData f : file3) {
                JSONObject r1 = new JSONObject();
                String filename = "";
                String name1 = f.getFileObj().getName();
                if(name1.contains(".")) {
                    String names[] = name1.split("\\.");
                   filename = names[names.length-1];
                }
                if(filename.length() > 0) {
                    r1.put("file_type",filename.toLowerCase());
                }else{
                    r1.put("file_type",f.getFileObj().getType());
                }
                log.error("howec:::::::::xxxxx21:"+f.getFileObj().getName());
                log.error("howec:::::::::xxxxx1:"+f.getFileObj().getType());
                log.error("howec:::::::::xxxxx2:"+f.getLoadUrl());
                InputStream stream1 = f.getInputStream();
                byte[] a = getByteData(stream1);
                r1.put("filebytes",a);
                json1.add(r1);
            }
            rs1.put("filebytes_array",json1);
            array1.add(rs1);
        }
        if(CollectionUtil.isNotEmpty(file4)) {
            JSONObject rs1 = new JSONObject();
            rs1.put("file_name","第四学历学历证学位证");
            JSONArray json1 = new JSONArray();
            for(FileData f : file4) {
                JSONObject r1 = new JSONObject();
                String filename = "";
                String name1 = f.getFileObj().getName();
                if(name1.contains(".")) {
                    String names[] = name1.split("\\.");
                   filename = names[names.length-1];
                }
                if(filename.length() > 0) {
                    r1.put("file_type",filename.toLowerCase());
                }else{
                    r1.put("file_type",f.getFileObj().getType());
                }
                log.error("howec:::::::::xxxxx21:"+f.getFileObj().getName());
                log.error("howec:::::::::xxxxx1:"+f.getFileObj().getType());
                log.error("howec:::::::::xxxxx2:"+f.getLoadUrl());
                InputStream stream1 = f.getInputStream();
                byte[] a = getByteData(stream1);
                r1.put("filebytes",a);
                json1.add(r1);
            }
            rs1.put("filebytes_array",json1);
            array1.add(rs1);
        }
        if(CollectionUtil.isNotEmpty(file5)) {
            JSONObject rs1 = new JSONObject();
            rs1.put("file_name","岗位证");
            JSONArray json1 = new JSONArray();
            for(FileData f : file5) {
                JSONObject r1 = new JSONObject();
                String filename = "";
                String name1 = f.getFileObj().getName();
                if(name1.contains(".")) {
                    String names[] = name1.split("\\.");
                   filename = names[names.length-1];
                }
                if(filename.length() > 0) {
                    r1.put("file_type",filename.toLowerCase());
                }else{
                    r1.put("file_type",f.getFileObj().getType());
                }
                log.error("howec:::::::::xxxxx21:"+f.getFileObj().getName());
                log.error("howec:::::::::xxxxx1:"+f.getFileObj().getType());
                log.error("howec:::::::::xxxxx2:"+f.getLoadUrl());
                InputStream stream1 = f.getInputStream();
                byte[] a = getByteData(stream1);
                r1.put("filebytes",a);
                json1.add(r1);
            }
            rs1.put("filebytes_array",json1);
            array1.add(rs1);
        }
        if(CollectionUtil.isNotEmpty(file6)) {
            JSONObject rs1 = new JSONObject();
            rs1.put("file_name","职称证");
            JSONArray json1 = new JSONArray();
            for(FileData f : file6) {
                JSONObject r1 = new JSONObject();
                String filename = "";
                String name1 = f.getFileObj().getName();
                if(name1.contains(".")) {
                    String names[] = name1.split("\\.");
                   filename = names[names.length-1];
                }
                if(filename.length() > 0) {
                    r1.put("file_type",filename.toLowerCase());
                }else{
                    r1.put("file_type",f.getFileObj().getType());
                }
                log.error("howec:::::::::xxxxx21:"+f.getFileObj().getName());
                log.error("howec:::::::::xxxxx1:"+f.getFileObj().getType());
                log.error("howec:::::::::xxxxx2:"+f.getLoadUrl());
                InputStream stream1 = f.getInputStream();
                byte[] a = getByteData(stream1);
                r1.put("filebytes",a);
                json1.add(r1);
            }
            rs1.put("filebytes_array",json1);
            array1.add(rs1);
        }
        if(CollectionUtil.isNotEmpty(file7)) {
            JSONObject rs1 = new JSONObject();
            rs1.put("file_name","执业资格证");
            JSONArray json1 = new JSONArray();
            for(FileData f : file7) {
                JSONObject r1 = new JSONObject();
                String filename = "";
                String name1 = f.getFileObj().getName();
                if(name1.contains(".")) {
                    String names[] = name1.split("\\.");
                   filename = names[names.length-1];
                }
                if(filename.length() > 0) {
                    r1.put("file_type",filename.toLowerCase());
                }else{
                    r1.put("file_type",f.getFileObj().getType());
                }
                log.error("howec:::::::::xxxxx21:"+f.getFileObj().getName());
                log.error("howec:::::::::xxxxx1:"+f.getFileObj().getType());
                log.error("howec:::::::::xxxxx2:"+f.getLoadUrl());
                InputStream stream1 = f.getInputStream();
                byte[] a = getByteData(stream1);
                r1.put("filebytes",a);
                json1.add(r1);
            }
            rs1.put("filebytes_array",json1);
            array1.add(rs1);
        }
        if(CollectionUtil.isNotEmpty(file8)) {
            JSONObject rs1 = new JSONObject();
            rs1.put("file_name","安全生产考核证");
            JSONArray json1 = new JSONArray();
            for(FileData f : file8) {
                JSONObject r1 = new JSONObject();
                String filename = "";
                String name1 = f.getFileObj().getName();
                if(name1.contains(".")) {
                    String names[] = name1.split("\\.");
                   filename = names[names.length-1];
                }
                if(filename.length() > 0) {
                    r1.put("file_type",filename.toLowerCase());
                }else{
                    r1.put("file_type",f.getFileObj().getType());
                }
                log.error("howec:::::::::xxxxx21:"+f.getFileObj().getName());
                log.error("howec:::::::::xxxxx1:"+f.getFileObj().getType());
                log.error("howec:::::::::xxxxx2:"+f.getLoadUrl());
                InputStream stream1 = f.getInputStream();
                byte[] a = getByteData(stream1);
                r1.put("filebytes",a);
                json1.add(r1);
            }
            rs1.put("filebytes_array",json1);
            array1.add(rs1);
        }
        if(CollectionUtil.isNotEmpty(file9)) {
            JSONObject rs1 = new JSONObject();
            rs1.put("file_name","身份证");
            JSONArray json1 = new JSONArray();
            for(FileData f : file9) {
                JSONObject r1 = new JSONObject();
                String filename = "";
                String name1 = f.getFileObj().getName();
                if(name1.contains(".")) {
                    String names[] = name1.split("\\.");
                   filename = names[names.length-1];
                }
                if(filename.length() > 0) {
                    r1.put("file_type",filename.toLowerCase());
                }else{
                    r1.put("file_type",f.getFileObj().getType());
                }
                log.error("howec:::::::::xxxxx21:"+f.getFileObj().getName());
                log.error("howec:::::::::xxxxx1:"+f.getFileObj().getType());
                log.error("howec:::::::::xxxxx2:"+f.getLoadUrl());
                InputStream stream1 = f.getInputStream();
                byte[] a = getByteData(stream1);
                r1.put("filebytes",a);
                json1.add(r1);
            }
            rs1.put("filebytes_array",json1);
            array1.add(rs1);
        }
        if(CollectionUtil.isNotEmpty(file10)) {
            JSONObject rs1 = new JSONObject();
            rs1.put("file_name","近期免冠照片");
            JSONArray json1 = new JSONArray();
            for(FileData f : file10) {
                JSONObject r1 = new JSONObject();
                String filename = "";
                String name1 = f.getFileObj().getName();
                if(name1.contains(".")) {
                    String names[] = name1.split("\\.");
                   filename = names[names.length-1];
                }
                if(filename.length() > 0) {
                    r1.put("file_type",filename.toLowerCase());
                }else{
                    r1.put("file_type",f.getFileObj().getType());
                }
                log.error("howec:::::::::xxxxx21:"+f.getFileObj().getName());
                log.error("howec:::::::::xxxxx1:"+f.getFileObj().getType());
                log.error("howec:::::::::xxxxx2:"+f.getLoadUrl());
                InputStream stream1 = f.getInputStream();
                byte[] a = getByteData(stream1);
                r1.put("filebytes",a);
                json1.add(r1);
            }
            rs1.put("filebytes_array",json1);
            array1.add(rs1);
        }
        return array1;
    }



    public byte[] getByteData(InputStream input) {
        try {
            return org.apache.commons.io.IOUtils.toByteArray(input);
        } catch (IOException e) {
            e.printStackTrace();
        }
        return null;
    }

    private List<FileData> getDxDt(String id) {
        List<FileData> rs = new ArrayList<>();
        try {
            if(!"0".equals(id)) {
                String ids[] = id.split(",");
                for(String s1 : ids) {
                    FileData file1 = fileDownloadService.downloadFile(Long.parseLong(s1));
                    if(file1.getFileObj()!=null && file1.getInputStream()!=null) {
                        rs.add(file1);
                    }
                }

            }
        }catch (Exception e){
            e.printStackTrace();
            log.error("获取附件错误："+e.getMessage());
        }
        return rs;
    }
}