package com.weaver.seconddev.sxjg.esb;

import com.alibaba.fastjson.JSONArray;
import com.alibaba.fastjson.JSONObject;
import com.weaver.common.base.entity.result.WeaResult;
import com.weaver.esb.api.rpc.EsbServerlessRpcRemoteInterface;
import com.weaver.seconddev.sxjg.util.NccApiUtil;
import com.weaver.seconddev.sxjg.util.NccResultUtil;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.stereotype.Service;

import java.util.HashMap;
import java.util.Map;

/**
 * 人员离职同步ncc
 *
 * 人员离职流程同步NCC
 * 10  1
 *
 */
@Service("esb_PersonLzToNcc_howe")
public class PersonLzToNcc implements EsbServerlessRpcRemoteInterface {
    private static final Logger log = LoggerFactory.getLogger(PersonLzToNcc.class);
    @Override
    public WeaResult<Map<String, Object>> execute(Map<String, Object> params) {
        Map<String, Object> finresult = new HashMap<>();
        finresult.put("code",200);
        String pk_psndoc = (String) params.get("pk_psndoc");//人员主键
        String pk_org = (String) params.get("pk_org");//所属组织（调配后的组织）
        String begindate = (String) params.get("begindate");//开始时间
        String pk_psncl = (String) params.get("pk_psncl");//人员类别
        if(pk_psncl.contains("_")) {
            pk_psncl = pk_psncl.split("_")[1];
        }

        String pk_dept = (String) params.get("pk_dept");//部门
        String pk_post = (String) params.get("pk_post");//岗位
        String pk_postseries = (String) params.get("pk_postseries");//岗位序列
        String pk_job = (String) params.get("pk_job");//职务
        String pk_jobgrade = (String) params.get("pk_jobgrade");//职级
        String jobglbdef1 = (String) params.get("jobglbdef1");//职级开始时间
        String trnsreason = (String) params.get("trnsreason");//异动原因
        String memo = (String) params.get("memo");//备注
        JSONArray array = new JSONArray();
        JSONObject rs = new JSONObject();
        rs.put("pk_psndoc",pk_psndoc);
        rs.put("pk_org",pk_org);
        rs.put("begindate",begindate);
        rs.put("pk_psncl",pk_psncl);
        rs.put("pk_dept",pk_dept);
        rs.put("pk_post",pk_post);
        rs.put("pk_postseries",pk_postseries);
        rs.put("pk_job",pk_job);
        rs.put("pk_jobgrade",pk_jobgrade);
        rs.put("jobglbdef1",jobglbdef1);
        rs.put("trnsreason",trnsreason);
        rs.put("memo",memo);
        array.add(rs);
        JSONObject finalrs = new JSONObject();
        finalrs.put("data",array);
        try {
            NccApiUtil nccApiUtil = new NccApiUtil();
            nccApiUtil.init();
            String token = nccApiUtil.getToken();
            String url = nccApiUtil.getBaseUrl()+"nccloud/api/hrtrn/openAPI/dimissionSync/entry";
            String rs11 = nccApiUtil.doJsonPost(url,token,finalrs.toJSONString());
            NccResultUtil rs2 = new NccResultUtil(rs11);
            if(rs2.getResult()) {
                return WeaResult.success(finresult);
            }else {
                finresult.put("code",500);
                finresult.put("msg",rs2.getDescription());
                return WeaResult.success(finresult);
            }
        }catch (Exception e){
            e.printStackTrace();
            finresult.put("code",500);
            finresult.put("msg",e.getMessage());
            log.error("howec:::::::::1:"+e.getMessage());
            return WeaResult.success(finresult);
        }
    }

}
