package com.weaver.seconddev.sxjg.util;

import javax.servlet.http.HttpServletRequest;
import java.io.UnsupportedEncodingException;
import java.net.URLEncoder;

public class FileUtils{

    /**
     * 下载文件名重新编码
     *
     * @param request  请求对象
     * @param fileName 文件名
     * @return 编码后的文件名
     */
    public static String setFileDownloadHeader(HttpServletRequest request, String fileName)throws UnsupportedEncodingException {

        final String agent = request.getHeader("USER-AGENT");
        String filename = fileName;

        //根据浏览器进行文件名的替换
        if(agent.contains("MSIE")){
            //IE浏览器
            filename = URLEncoder.encode(filename,"utf-8");
            filename = filename.replace("+"," ");
        }else if(agent.contains("Firefox")){
            //火狐浏览器
            filename = new String(fileName.getBytes(),"ISO8859-1");
        }else if(agent.contains("Chrome")){
            //谷歌浏览器
            filename = URLEncoder.encode(filename,"utf-8");
        }else{
            // 其它浏览器
            filename = URLEncoder.encode(filename, "utf-8");
        }
        return filename;
    }
}


